
Core - Bug # 65378

Status: Resolved Priority: Should have
Author: Stephan grass Category: Image Generation
Created: 2015-02-27 Assigned To:
Updated: 2015-03-12 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity: medium
Is Regression: Yes
Sprint Focus:
Subject: Scaling/cropping images in GIFBUILDER does not work
Description

I am using following TypoScript to center an image on a specified rectangle.
This will not work after updating to 6.2.10

lib.prodImage = COA
lib.prodImage {
    10 = IMAGE
    10 {
        file = GIFBUILDER
        file {
            format = jpg
            workArea = 0,0,200,200
            XY = 200,200
            backColor = #ffffff
            quality = 95

10 = IMAGE
            10 {
                file.import.current = 1
                file.maxH = 200
                file.maxW = 200
                align = c,c
            }
        }
    }
}

Related issues:
related to Core - Bug # 64224: GIFBUILDER with FAL and UTF-8 filesystem Resolved 2015-01-09
related to Core - Bug # 62184: Exception using GIFBUILDER in css_styled_conte... Resolved 2014-10-13
related to Core - Bug # 65535: Exception: Serialization of 'Closure' is not a... Under Review 2015-03-05
related to Core - Bug # 65842: Cropping Images in GIFBUILDER is broken since ... Resolved 2015-03-19
related to Core - Bug # 65925: images are not processed / rendered in TYPO3 V... Closed 2015-03-23
duplicated by Core - Bug # 65599: After Update from 6.2.9 --> 6.2.10 TypoScri... Closed 2015-03-08

Associated revisions
Revision ef5f6cc8 - 2015-03-04 19:26 - Torben Hansen

[BUGFIX] Regression when scaling/cropping in GIFBUILDER
The fix for issue #64224 introduced a regression in GIFBUILDER
resulting in problems with image scaling/cropping.

For $fileInfo and $maskInfo: use 'processedFile' for FAL files
if available and correctly distinguish between FAL- and non-FAL files
otherwise by checking for 'origFile'.

Resolves: #65378
Related: #64224
Releases: master, 6.2
Change-Id: Ib472bdcdc7f814e50ebd18e084f5fbe7d09fc410
Reviewed-on: http://review.typo3.org/37483
Reviewed-by: Stephan Großberndt <stephan@grossberndt.de>
Tested-by: Stephan Großberndt <stephan@grossberndt.de>
Reviewed-by: Frans Saris <franssaris@gmail.com>
Tested-by: Stefan Froemken <froemken@gmail.com>
Tested-by: Christoph Lehmann <christoph.lehmann@networkteam.com>
Tested-by: Philipp Mueller <philipp.mueller@lavitto.ch>
Reviewed-by: Christian Kuhn <lolli@schwarzbu.ch>
Tested-by: Christian Kuhn <lolli@schwarzbu.ch>

Revision 835be9a8 - 2015-03-04 19:27 - Torben Hansen

[BUGFIX] Regression when scaling/cropping in GIFBUILDER

The fix for issue #64224 introduced a regression in GIFBUILDER
resulting in problems with image scaling/cropping.

For $fileInfo and $maskInfo: use 'processedFile' for FAL files
if available and correctly distinguish between FAL- and non-FAL files
otherwise by checking for 'origFile'.

Resolves: #65378
Related: #64224
Releases: master, 6.2
Change-Id: Ib472bdcdc7f814e50ebd18e084f5fbe7d09fc410
Reviewed-on: http://review.typo3.org/37533
Reviewed-by: Christian Kuhn <lolli@schwarzbu.ch>
Tested-by: Christian Kuhn <lolli@schwarzbu.ch>

Revision c5b7a0d9 - 2015-05-15 14:28 - Morton Jonuschat

[BUGFIX] Temporary filename collision in imageMagickConvert()

Add more entropy to the temporary filename used by imageMagickConvert()
to ensure different processing configurations resulting in the same
output dimensions get different temporary names.

In combination with LocalDriver moving the temporary file to a different
location and file_exists_typo3temp_file() having a 30s window where it
doesn't detect the moved file (when the user enabled
$TYPO3_CONF_VARS['GFX']['enable_typo3temp_db_tracking']) this
leads to entries in the sys_processed_file table with a width and
height of 0, thus referencing the original file and resulting in
unscaled images showing in the frontend.

Resolves: #65842
Resolves: #63519
Resolves: #60215
Related: #65378
Releases: 6.2
Change-Id: I42748d0899bf1e24f9f92f2e55802d64309c5704
Reviewed-on: http://review.typo3.org/39373
Reviewed-by: Stephan Großberndt <stephan@grossberndt.de>
Reviewed-by: Frans Saris <franssaris@gmail.com>
Reviewed-by: Andreas Fernandez <typo3@scripting-base.de>
Tested-by: Andreas Fernandez <typo3@scripting-base.de>
Reviewed-by: Markus Klein <markus.klein@typo3.org>
Tested-by: Markus Klein <markus.klein@typo3.org>

History
#1 - 2015-02-27 12:05 - Geddo no-lastname-given

same here. I'm using gifbuilder to scale images + watermarks etc. Everything was fine in 6.2.9 and is now messed up in 6.2.10
Here is a test-snippet

page = PAGE
page {
    config {
        no_cache = 1
    }
    10 = IMAGE
    10 {
        file = GIFBUILDER
        file {
            format = jpg
            quality = 90
            XY = 500,500

            10 = IMAGE 
            10 {
                file = fileadmin/template/img/test.jpg
                file.width = 500c # HAS NO EFFECT in 6.2.10!
                file.height= 500c # HAS NO EFFECT in 6.2.10!    
            } 
        }
    }
}

OK folks so here is the deal: https://review.typo3.org/#/c/36180/3/typo3/sysext/frontend/Classes/Imaging/GifBuilder.php

$fileInfo3 gets the correctly scaled, processed image while $fileInfo['originalFile']->getForLocalProcessing(FALSE) delivers the original, unscaled
image. 
So I don't know why this condition was implemented but at least it should rescale the originalFile like the one in $fileInfo3

#2 - 2015-02-27 16:55 - Claus Harup

I have the same problem with any GIFBUILDER configuration after upgrading to 6.2.10 :-|

#3 - 2015-02-27 16:58 - Claus Harup
- File screen.jpg added

Attachment to previous bug....

#4 - 2015-03-03 09:09 - Philipp Mueller

Since TYPO3 6.2.10 I've the same problem like Geddo with GIFBUILDER. The problem occurs with width= and height=, too.
I work with:
    -  GraphicsMagick 1.3.18 2013-03-10 Q8
    -  PHP 5.5.9
    -  Ubuntu 14.04.2 LTS.

#5 - 2015-03-03 09:37 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37483

#6 - 2015-03-03 09:38 - Adrian no-lastname-given

Same here. After upgrading TYPO3 from version 6.2.9 to 6.2.10 the scaling images using GIFBUILDER didn't work. When I'm testing image
processing in Instal Tool everything looks ok, byt when I want to change img using GIFBUILDER scaling img didn't work. I'm using GIFBUILDER to
adding watermark to yag gallery.

#7 - 2015-03-03 10:50 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37483

#8 - 2015-03-03 10:59 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37483

#9 - 2015-03-03 12:01 - Gerrit Code Review
Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37483

#10 - 2015-03-03 12:31 - Stephan Großberndt
- Subject changed from Typo3 6.2.10 Gifbuilder to Scaling/cropping images in GIFBUILDER does not work
- Target version set to next-patchlevel
- Complexity set to medium
- Is Regression changed from No to Yes

This is a regression in TYPO3 CMS 6.2.10 caused by https://review.typo3.org/#/c/36180

#11 - 2015-03-03 12:47 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37483

#12 - 2015-03-03 17:03 - Stephan grass

Under php 5.4.34 GifBuilder.php will cause the error:

Parse error: syntax error, unexpected 'class' (T_CLASS), expecting identifier (T_STRING) or variable (T_VARIABLE) or '{' or '$' in
/Users/stephangrass/Documents/_Webs_/MR-Chemie/typo3/typo3_src-6.2.10/typo3/sysext/frontend/Classes/Imaging/GifBuilder.php on line 141

#13 - 2015-03-04 11:57 - Christian Kuhn

@Stephan: I can not confirm your "fatal" report (our test environment would also have found that in travis-ci for php 5.4 on 6.2.10)

#14 - 2015-03-04 19:27 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37533

#15 - 2015-03-04 19:30 - Torben Hansen
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:ef5f6cc8ee556c66caf8787635ef049a68e88006.

#16 - 2015-03-11 16:39 - Ralph Brugger

Under php 5.4.34 GifBuilder.php will cause the error:
Same for me wihtin

Parse error: syntax error, unexpected 'class' (T_CLASS), expecting identifier (T_STRING) or variable (T_VARIABLE) or '{' or '$' in
/Users/stephangrass/Documents/_Webs_/MR-Chemie/typo3/typo3_src-6.2.10/typo3/sysext/frontend/Classes/Imaging/GifBuilder.php on line
141

This worked for me: 4 or 5 times in this file:

... GeneralUtility::makeInstance('TYPO3\\CMS\\Frontend\\ContentObject\\ContentObjectRenderer');

#17 - 2015-03-12 11:58 - Christoph Lehmann

The applied changeset breaks PHP 5.3.10 too

Files
screen.jpg 204.9 kB 2015-02-27 Claus Harup
